//*****************************************************************************
//      C++ functions for:
// 		Extensions to the libsx graphics routines
//
//      Written by Stuart Prescott:
//              Written:                20/10/1996
//              Last Modified:          26/10/1996
//
//      Libraries Required:
//              libsx (Dominic Giamapolo - Athena Widget Set)
//
//      System headers:
//              Streamed I/O
//              Formatted I/O
//              strings 
//
//      Other Object Classes used:
//              fonts
//
//*****************************************************************************

  
#include <string.h>  
#include <stdio.h> 
#include <iostream.h>  
  
#define DEBUGGETFONT	0  
#define DEBUGFANCYTEXT	0  
#define CHECKFONT	0

extern "C"  
{  
    #include <libsx.h>  
}  
  
#include "grafxten.h"  
#include "fontdefs.h"

extern FontDefs *fonts;

//*****************************************************************************
//*****************************************************************************
void DrawTextH (Widget draw_area, int heading, char* lwf, int x, int y)  
{  
    //**** pretty prints the name for the orbital with the sub/super -
    // scripting required.
  
    char b;  
    char let[2];  
    let[1]='\0';  
    int	i,slen;  
 
    XFont font, sfont, ssfont;

    if (heading)
    {
	font  = fonts->title;
	sfont = fonts->Stitle;
	ssfont= fonts->SStitle;
    }
    else
    {
	font  = fonts->menu;
	sfont = fonts->Smenu;
	ssfont= fonts->SSmenu;
    }	 
 
    SetWidgetFont(draw_area, font); 
  
    slen= strlen (lwf);  

    let[0]=lwf[0];
    DrawText(let, x, y);
    x += TextWidth(font, let);
  
    for (i= 1; i<=slen-1; ++i)  
    {  
	b= let[0];  
        let[0]=lwf[i];  
	
	if (b>='x' && b<='z' && let[0]>='0' && let[0]<='9')  
        {  
	    SetWidgetFont(draw_area, ssfont);  
  
            DrawText (let, x,y);  
            x += TextWidth(ssfont, let); 
	    #if DEBUGFANCYTEXT 
	    	printf ( "%s len=%d ", let, TextWidth(ssfont, let));  
	    #endif 
        }  
	else  
        { 
	    SetWidgetFont(draw_area, sfont); 
            DrawText (let, x,y+4);  
            x += TextWidth(sfont, let);  
 
	    #if DEBUGFANCYTEXT 
		printf ("%s len=%d ", let, TextWidth (sfont, let)); 
	    #endif	 
	} 
	#if DEBUGFANCYTEXT 
	    printf (" (%d,%d)\n", x, y); 
	#endif  
    }  
  
    #if DEBUGFANCYTEXT  
	cout << " . . .";  
    #endif  
  
    SetWidgetFont (draw_area, font); 
 
    return; 
}  
  
// *************************************************************************  
// *************************************************************************  
