//*****************************************************************************
//      C++ functions for:
//		information window class
//
//      Written by Stuart Prescott:
//              Written:                16/10/1996
//              Last Modified:          27/10/1996
//
//      Libraries Required:
//              libsx (Dominic Giamapolo - Athena Widget Set)
//
//      Other Object Classes used:
//              fonts
//
//*****************************************************************************

extern "C" {
    #include <libsx.h>
}

#include "info.h"
#include "fontdefs.h"

extern FontDefs *fonts;

//***************************************************************************  
//***************************************************************************  
InfoWin::InfoWin()
{
    //**** sets up an information window containing the text 
    // contained in the file "hyd_info.txt"

    win=MakeWindow("Info About Hyd", SAME_DISPLAY, EXCLUSIVE_WINDOW);
    
    text_area=MakeTextWidget("hyd_info.txt", TRUE, FALSE, 420, 500);

    SetWidgetFont(text_area, fonts->infotext);

    button=MakeButton("Close", InfoWinClose_Button, this);

    SetWidgetPos (button, 
		  PLACE_UNDER, text_area, 
		  NO_CARE, NULL);
		
    ShowDisplay();

    MainLoop();			//don't allow anything else to happen
}

//***************************************************************************  
//***************************************************************************  
InfoWin::~InfoWin()
{
    //removes the info window

    SetCurrentWindow(win);

    CloseWindow();
}

//***************************************************************************  
//***************************************************************************  
void InfoWinClose_Button(Widget w, void *data)
{
    // button CB to close the info window

    InfoWin *me = (InfoWin *)data;

    delete me;

    return;
}
